/*
 * Copyright (c) 2013, webvariants GbR, http://www.webvariants.de
 *
 * This file is released under the terms of the MIT license. You can find the
 * complete text in the attached LICENSE file or online at:
 *
 * http://www.opensource.org/licenses/mit-license.php
 */

jQuery(function($) {
	if (!('wvToggleFieldset' in $.fn)) return;

	var cookieName = 'wv42_rbac_hidden', hidden = $.cookie(cookieName);
	hidden = (hidden === '' || hidden === null) ? [] : hidden.split(',');

	/////////////////////////////////////////////////////////////////////////////
	// add toggle fieldset behaviour

	$('#wv42rbac-role-form fieldset').slice(1, -1).wvToggleFieldset({
		isHidden: function(fieldset) {
			var id = fieldset.attr('id');
			return $.inArray(id, hidden) >= 0;
		},

		onHide: function(fieldset) {
			var id = fieldset.attr('id');
			hidden.push(id);
			$.cookie(cookieName, hidden.join(','), 30);
		},

		onShow: function(fieldset) {
			var id = fieldset.attr('id');
			hidden.splice(hidden.indexOf(id), 1);
			$.cookie(cookieName, hidden.join(','), 30);
		}
	});
});
